;******************************************************
;  ਢ HDD  CD
;  室 ⥪ 㫠  쥢.
;   ࠡ⪠ Mario79
;******************************************************

;****************************************************
;*                  HDD  CD                   *
;****************************************************
FindHDD:
        mov     [ChannelNumber],1
        mov     [DiskNumber],0
        call    FindHDD_3
        mov     [DiskNumber],1
        call    FindHDD_3
        inc     [ChannelNumber]
        mov     [DiskNumber],0
        call    FindHDD_3
        mov     [DiskNumber],1
        call    FindHDD_1
        jmp     EndFindHDD

FindHDD_1:
        call    ReadHDD_ID
        cmp     [DevErrorCode],0
        jne     FindHDD_2
        cmp     [Sector512+6],word 16
        ja      FindHDD_2
        cmp     [Sector512+12],word 255
        ja      FindHDD_2
        inc     byte [0x40001]
        jmp     FindHDD_2_2
   FindHDD_2:
        call    DeviceReset
        cmp     [DevErrorCode],0
        jne     FindHDD_2_2
        call    ReadCD_ID
        cmp     [DevErrorCode],0
        jne      FindHDD_2_2
        inc     byte [0x40001]
        inc     byte [0x40001]
   FindHDD_2_2:
        ret

FindHDD_3:
        call    FindHDD_1
        shl     byte [0x40001],2  
        ret


;  뢠 ᥪ  ० LBA
SectorAddress   DD ?

;*************************************************
;*              *
;* 室 ࠬ । १  *
;* ६:                                   *
;* ChannelNumber -   (1  2);       *
;* DiskNumber -  ᪠   (0  1). *
;* 䨪樮   뢠     *
;*  ᨢ Sector512.                           *
;*************************************************
ReadHDD_ID:
;  ० CHS
        mov     [ATAAddressMode],0
; ᫠  䨪樨 ன⢠
        mov     [ATAFeatures],0
        mov     [ATAHead],0
        mov     [ATACommand],0ECh
        call    SendCommandToHDD
        cmp     [DevErrorCode],0 ;஢  訡
        jne     @@End  ;, ࠭  訡
        mov     DX,[ATABasePortAddr]
        add     DX,7     ; ॣ ﭨ
        mov  ecx,0xffff
@@WaitCompleet:
        ; ஢ ६ 믮 
        dec  ecx
        cmp  ecx,0
        je     @@Error1   ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet
        test    AL,1     ;ﭨ ᨣ ERR
        jnz     @@Error6
        test    AL,08h   ;ﭨ ᨣ DRQ
        jz      @@WaitCompleet
; ਭ    ஫
;        mov     AX,DS
;        mov     ES,AX
        mov     EDI,Sector512  ;offset Sector512
        mov     DX,[ATABasePortAddr] ;ॣ 
        mov     CX,256   ;᫮ 뢠 ᫮
        rep     insw     ;ਭ  
        jmp @@End
;   訡
@@Error1:
        mov     [DevErrorCode],1
        jmp @@End
@@Error6:
        mov     [DevErrorCode],6
@@End:  ret



; ⠭    1  2
StandardATABases DW 1F0h, 170h
;  
ChannelNumber   DW ?
;  ᪠
DiskNumber      DB ?
;   㯯 ⮢ ஫ ATA
ATABasePortAddr DW ?
; ࠬ ATA-
ATAFeatures     DB ? ;ᮡ
ATASectorCount  DB ? ;⢮ ࠡ뢠 ᥪ஢
ATASectorNumber DB ? ; 砫쭮 ᥪ
ATACylinder     DW ? ; 砫쭮 樫
ATAHead         DB ? ; 砫쭮 
ATAAddressMode  DB ? ;० 樨 (0 - CHS, 1 - LBA)
ATACommand      DB ? ; , 饩 믮
;  訡 (0 -  訡, 1 - ॢ襭 ⨬
; ࢠ , 2 -   ० 樨,
; 3 -   , 4 -   ᪠,
; 5 -   , 6 - 訡  믮
; )
DevErrorCode DB ?

;****************************************************
;*                      *
;* 室 ࠬ । १     *
;* ६:                                      *
;* ChannelNumber -   (1  2);          *
;* DiskNumber -  ᪠ (0  1);              *
;* ATAFeatures - "ᮡ";                     *
;* ATASectorCount - ⢮ ᥪ஢;            *
;* ATASectorNumber -  砫쭮 ᥪ;      *
;* ATACylinder -  砫쭮 樫;         *
;* ATAHead -  砫쭮 ;               *
;* ATAAddressMode - ० 樨 (0-CHS, 1-LBA); *
;* ATACommand -  .                        *
;* ᫥ ᯥ譮 믮 㭪樨:              *
;*  ATABasePortAddr -   HDD;           *
;*  DevErrorCode - .                           *
;*   訡  DevErrorCode 㤥    *
;* 饭  訡.                            *
;****************************************************
SendCommandToHDD:
; ஢ 祭  ०
        cmp     [ATAAddressMode],1
        ja      @@Err2
; ஢ ४⭮  
        mov     BX,[ChannelNumber]
        cmp     BX,1
        jb      @@Err3
        cmp     BX,2
        ja      @@Err3
; ⠭  
        dec     BX
        shl     BX,1
        movzx   ebx,bx
        mov     AX,[ebx+StandardATABases]
        mov     [ATABasePortAddr],AX
;  ⮢ HDD  ਥ 
        ;  㦭 
        mov     DX,[ATABasePortAddr]
        add     DX,6    ; ॣ 
        mov     AL,[DiskNumber]
        cmp     AL,1    ;஢  ᪠
        ja      @@Err4
        shl     AL,4
        or      AL,10100000b
        out     DX,AL
        ; ,    㤥 ⮢
        inc     DX
        mov  ecx,0xfff
@@WaitHDReady:
        ; ஢ ६ 
        dec  ecx
        cmp  ecx,0
        je     @@Err1
        ;  ॣ ﭨ
        in      AL,DX
        ; ஢ ﭨ ᨣ BSY
        test    AL,80h
        jnz     @@WaitHDReady
        ; ஢ ﭨ ᨣ DRQ
        test    AL,08h
        jnz     @@WaitHDReady
; 㧨   ॣ ஫
        mov     DX,[ATABasePortAddr]
        inc     DX      ;ॣ "ᮡ⥩"
        mov     AL,[ATAFeatures]
        out     DX,AL
        inc     DX      ;稪 ᥪ஢
        mov     AL,[ATASectorCount]
        out     DX,AL
        inc     DX      ;ॣ  ᥪ
        mov     AL,[ATASectorNumber]
        out     DX,AL
        inc     DX      ; 樫 (訩 )
        mov     AX,[ATACylinder]
        out     DX,AL
        inc     DX      ; 樫 (訩 )
        mov     AL,AH
        out     DX,AL
        inc     DX      ; / ᪠
        mov     AL,[DiskNumber]
        shl     AL,4
        cmp     [ATAHead],0Fh ;஢  
        ja      @@Err5
        or      AL,[ATAHead]
        or      AL,10100000b
        mov     AH,[ATAAddressMode]
        shl     AH,6
        or      AL,AH
        out     DX,AL
; ᫠ 
        mov     AL,[ATACommand]
        inc     DX      ;ॣ 
        out     DX,AL
;  ਧ 訡
        mov     [DevErrorCode],0
        jmp @@End_2
;   訡
@@Err1: mov     [DevErrorCode],1
        jmp @@End_2
@@Err2: mov     [DevErrorCode],2
        jmp @@End_2
@@Err3: mov     [DevErrorCode],3
        jmp @@End_2
@@Err4: mov     [DevErrorCode],4
        jmp @@End_2
@@Err5: mov     [DevErrorCode],5
; 襭 ࠡ ணࠬ
@@End_2: 
        ret

;*************************************************
;*        ATAPI    *
;* 室 ࠬ । १  *
;* ଥ:                                    *
;* ChannelNumber -  ;                 *
;* DiskNumber -  ᪠  .           *
;* 䨪樮   뢠     *
;*  ᨢ Sector512.                           *
;*************************************************
ReadCD_ID:
;  ० CHS
        mov     [ATAAddressMode],0
; ᫠  䨪樨 ன⢠
        mov     [ATAFeatures],0
        mov     [ATASectorCount],0
        mov     [ATASectorNumber],0
        mov     [ATACylinder],0
        mov     [ATAHead],0
        mov     [ATACommand],0A1h
        call    SendCommandToHDD
        cmp     [DevErrorCode],0 ;஢  訡
        jne     @@End_1  ;, ࠭  訡
;  ⮢  HDD
        mov     DX,[ATABasePortAddr]
        add     DX,7   ; 17h
        mov  ecx,0xffff
@@WaitCompleet_1:
        ; ஢ ६
        dec  ecx
        cmp  ecx,0
        je     @@Error1_1  ;訡 ⠩-
        ; ஢ ⮢
        in      AL,DX
        test    AL,80h   ;ﭨ ᨣ BSY
        jnz     @@WaitCompleet_1
        test    AL,1     ;ﭨ ᨣ ERR
        jnz     @@Error6_1
        test    AL,08h   ;ﭨ ᨣ DRQ
        jz      @@WaitCompleet_1
; ਭ    ஫
;        mov     AX,DS
;        mov     ES,AX
        mov     EDI,Sector512  ;offset Sector512
        mov     DX,[ATABasePortAddr] ; 1x0h
        mov     CX,256 ;᫮ 뢠 ᫮
        rep     insw
        jmp @@End_1
;   訡
@@Error1_1:
        mov     [DevErrorCode],1
        jmp @@End_1
@@Error6_1:
        mov     [DevErrorCode],6
@@End_1:
        ret

;*************************************************
;*                                *
;* 室 ࠬ । १  *
;* ६:                                   *
;* ChannelNumber -   (1  2);       *
;* DiskNumber -  ᪠ (0  1).           *
;*************************************************
DeviceReset:
; ஢ ४⭮  
        mov     BX,[ChannelNumber]
        cmp     BX,1
        jb      @@Err3_2
        cmp     BX,2
        ja      @@Err3_2
; ⠭  
        dec     BX
        shl     BX,1
        movzx   ebx,bx
        mov     DX,[ebx+StandardATABases]
        mov     [ATABasePortAddr],DX
;  㦭 
        add     DX,6    ; ॣ 
        mov     AL,[DiskNumber]
        cmp     AL,1    ;஢  ᪠
        ja      @@Err4_2
        shl     AL,4
        or      AL,10100000b
        out     DX,AL
; ᫠  ""
        mov     AL,08h
        inc     DX      ;ॣ 
        out     DX,AL
        mov     ecx,0xffff
@@WaitHDReady_1:
        ; ஢ ६ 
        dec     ecx
        cmp     ecx,0
        je      @@Err1_2 ;訡 ⠩-
        ;  ॣ ﭨ
        in      AL,DX
        ; ஢ ﭨ ᨣ BSY
        test    AL,80h
        jnz     @@WaitHDReady_1
;  ਧ 訡
        mov     [DevErrorCode],0
        jmp @@End_3
; ࠡ⪠ 訡
@@Err1_2: mov     [DevErrorCode],1
        jmp @@End_3
@@Err3_2: mov     [DevErrorCode],3
        jmp @@End_3
@@Err4_2: mov     [DevErrorCode],4
;   訡
@@End_3:
        ret

EndFindHDD:

