;
;   By Pavlushin Evgeni Mini Sample for ASCL
;   Compile with FASM for Menuet
;

use32
               org    0x0
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x10000f                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon

include 'ascl.inc'

START:                          ; start of execution
     call draw_window

still:
    wtevent red,key,button
    jmp  still

  red:                          ; redraw
    call draw_window
    jmp  still

  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40
    mov  [keyid],ah
    call draw_window
    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:

    startwd
    window 100,100,200,100,0x83ffffff
    label 8,8,'KEYBOARD ASCII-CODES',0x00ddeeff
    label 8,31,'DEC:',0x00221100
    label 8,54,'HEX:',0x00221100
    label 8,77,'BIN:',0x00221100
    outcount [keyid],40,31,0x224466,3*65536
    outcount [keyid],40,54,0x224466,3*65536+256
    outcount [keyid],40,77,0x224466,8*65536+512
    endwd
    ret

keyid:db 0
I_END:

