;
;   GIF Load and Show Mini Sample by Pavlushin Evgeni for ASCL
;   Load bmp image from hd and show with macros
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
;step1 load gif file to gif_file_area, size is = gif file size + 50 bytes
;      'path to file',offset of dest area,temp area for 58 func (2000 bytes)
    loadfile '/hd/1/meos/ASCL8G/pict.gif',gif_file_area,temp_zone
;step2 define offset of hash area for unpacking gif file
;      size 16384+4 bytes
    gif_hash_offset = gif_hash_area
;step3 converting gif format to img format for easy out to screen
;      gif_file_area - offset of gif load file
;      img_area      - offset of img image
    giftoimg gif_file_area,img_area
;step4 out image from img_area
    call draw_window

;Main loop wait for event with 10msec
still:
    timeevent 10,no_event,red,key,button
  no_event:
    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    int  0x40                   ; read (eax=2)
    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window   40,40,(209+9),(134+26),window_Skinned+0x00ffffff
    label    8,8,'ASCL Load&Show GIF Picture',cl_White+font_Big
    setimg   5,22,img_area
    endwd
    ret

; DATA AREA
IM_END:
;gif_file_area ~21500
gif_file_area:
rb 21500
img_area:
rb (209*134*3+8)*16   ;16 frames
gif_hash_area:
rd 4096+1      ;hash area size for unpacking GIF
temp_zone:
rd 2000        ;temp_zone for loadfile macros
I_END:
